package jrummikub.control.network;

import jrummikub.util.Event;
import jrummikub.util.Event3;
import jrummikub.util.IEvent;
import jrummikub.util.IEvent3;
import jrummikub.util.IListener;
import jrummikub.util.IListener3;
import jrummikub.view.IView;

public class LoginControl {
	private IView view;
	private Event3<String, String, String> loginEvent = new Event3<String, String, String>();
	private Event cancelEvent = new Event();

	public LoginControl(final IView view) {
		this.view = view;
		view.getLoginPanel().getLoginEvent()
				.add(new IListener3<String, String, String>() {
					@Override
					public void handle(String userName, String password,
							String channelName) {
						view.showLoginPanel(false);
						loginEvent.emit(userName, password, channelName);
					}
				});

		view.getLoginPanel().getCancelEvent().add(new IListener() {
			@Override
			public void handle() {
				view.showLoginPanel(false);
				cancelEvent.emit();
			}
		});
	}

	public void startLogin() {
		view.clearView();
		view.showLoginPanel(true);
	}

	public IEvent3<String, String, String> getLoginEvent() {
		return loginEvent;
	}

	public IEvent getCancelEvent() {
		return cancelEvent;
	}

}
